diff -Naur src.pgsql/backend/access/bitmap/bitmapxlog.c src.bitmap/backend/access/bitmap/bitmapxlog.c
--- src.pgsql/backend/access/bitmap/bitmapxlog.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/bitmapxlog.c	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,475 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapxlog.c
+ *	WAL replay logic for the bitmap index.
+ *
+ * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * IDENTIFICATION
+ *	$PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include <unistd.h>
+
+#include "access/bitmap.h"
+#include "access/xlogutils.h"
+
+/*
+ * _bitmap_xlog_newpage() -- create a new page.
+ */
+static void
+_bitmap_xlog_newpage(bool redo, XLogRecPtr lsn, XLogRecord *record)
+{
+	xl_bm_newpage	*xlrec = (xl_bm_newpage*) XLogRecGetData(record);
+
+	Relation		reln;
+	Page			page;
+	uint8			info;
+
+	info = record->xl_info & ~XLR_INFO_MASK;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer		buffer;
+
+		buffer = XLogReadBuffer(reln, xlrec->bm_new_blkno, true);
+		if (!BufferIsValid(buffer))
+			elog(PANIC, "_bitmap_xlog_newpage: block unfound: %d", 
+				 xlrec->bm_new_blkno);
+
+		page = BufferGetPage(buffer);
+
+		if (XLByteLT(PageGetLSN(page), lsn))
+		{
+			BMMetaPage	metapage;
+
+			switch (info)
+			{
+				case XLOG_BITMAP_INSERT_NEWMETA:
+					if(PageIsNew(page))
+						PageInit(page, BufferGetPageSize(buffer), 0);
+					metapage = (BMMetaPage) PageGetContents(page) ;
+					metapage->bm_num_tuples = 0;
+					metapage->bm_need_rebuilt = false;
+					break;
+				case XLOG_BITMAP_INSERT_NEWLOV:
+					_bitmap_init_lovpage(reln, buffer);
+					break;
+				case XLOG_BITMAP_INSERT_NEWBITMAP:
+					_bitmap_init_bitmappage(reln, buffer);
+					break;
+				default:
+					elog(PANIC, "bitmap_redo: unknown newpage op code %u", info);
+			}
+
+			PageSetLSN(page, lsn);
+			PageSetTLI(page, ThisTimeLineID);
+			_bitmap_wrtbuf(buffer);
+		}
+
+		else {
+			_bitmap_relbuf(buffer);
+		}
+	}
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_lovitem() -- insert a new lov item.
+ */
+static void
+_bitmap_xlog_insert_lovitem(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_lovitem	*xlrec = (xl_bm_lovitem*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer			lovBuffer;
+		Page			lovPage;
+
+		lovBuffer = XLogReadBuffer(reln, xlrec->bm_lov_blkno, false);
+		if (!BufferIsValid(lovBuffer))
+			elog(PANIC, "bm_insert_redo: (_bitmap_xlog_insert_lovitem)"
+						" block unfound: %d",
+				 xlrec->bm_lov_blkno);
+
+		lovPage = BufferGetPage(lovBuffer);
+
+		if (XLByteLT(PageGetLSN(lovPage), lsn))
+		{
+			if(xlrec->bm_isNewItem)
+			{
+				OffsetNumber	newOffset, itemSize;
+
+				newOffset = OffsetNumberNext(PageGetMaxOffsetNumber(lovPage));
+				if (newOffset != xlrec->bm_lov_offset)
+					elog(PANIC, "bm_insert_redo: LOV item is not inserted "
+								"in pos %d(requested %d)",
+						 newOffset, xlrec->bm_lov_offset);
+
+				itemSize = sizeof(BMLOVItemData);
+				if (itemSize > PageGetFreeSpace(lovPage))
+					elog(PANIC, 
+						 "bm_insert_redo: not enough space in LOV page %d",
+						 xlrec->bm_lov_blkno);
+		
+				if (PageAddItem(lovPage, (Item)&(xlrec->bm_lovItem), itemSize, 
+								newOffset, LP_USED) == InvalidOffsetNumber)
+					ereport(ERROR,
+							(errcode(ERRCODE_INTERNAL_ERROR),
+							errmsg("failed to add LOV item to \"%s\"",
+							RelationGetRelationName(reln))));
+			}
+			else
+			{
+				/* XXX: we don't do anything with oldLovItem here ! */
+				BMLOVItem oldLovItem;
+				oldLovItem = (BMLOVItem) PageGetItem(lovPage, 
+								PageGetItemId(lovPage, xlrec->bm_lov_offset));
+
+				memcpy(oldLovItem, &(xlrec->bm_lovItem), sizeof(BMLOVItemData));
+			}
+
+			PageSetLSN(lovPage, lsn);
+			PageSetTLI(lovPage, ThisTimeLineID);
+			_bitmap_wrtbuf(lovBuffer);
+		}
+		else
+			_bitmap_relbuf(lovBuffer);
+	}
+
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_meta() -- update a metapage.
+ */
+static void
+_bitmap_xlog_insert_meta(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_metapage	*xlrec = (xl_bm_metapage*) XLogRecGetData(record);
+	Relation		reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer			metabuf;
+		Page			mp;
+		BMMetaPage		metapage;
+
+		metabuf = XLogReadBuffer(reln, BM_METAPAGE, false);
+		if (!BufferIsValid(metabuf))
+			elog(PANIC, "bm_insert_redo: (_bitmap_xlog_insert_meta) "
+						"block unfound: %d", BM_METAPAGE);
+
+		/* restore the page */
+		mp = BufferGetPage(metabuf);
+		metapage = (BMMetaPage)PageGetContents(mp);
+
+		if (XLByteLT(PageGetLSN(mp), lsn))
+		{
+			metapage->bm_num_tuples = xlrec->bm_num_tuples;
+			metapage->bm_lov_heapId = xlrec->bm_lov_heapId;
+			metapage->bm_lov_indexId = xlrec->bm_lov_indexId;
+			metapage->bm_lov_lastpage = xlrec->bm_lov_lastpage;
+			metapage->bm_need_rebuilt = xlrec->bm_need_rebuilt;
+
+			PageSetLSN(mp, lsn);
+			PageSetTLI(mp, ThisTimeLineID);
+			_bitmap_wrtbuf(metabuf);
+		}
+		else
+			_bitmap_relbuf(metabuf);
+	}
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_bitmap() -- update a bitmap page.
+ */
+static void
+_bitmap_xlog_insert_bitmap(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_bitmappage	*xlrec = (xl_bm_bitmappage*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer	bitmapBuffer;
+		Page	bitmapPage;
+		BMBitmapOpaque	bitmapPageOpaque ;
+
+		bitmapBuffer = XLogReadBuffer(reln, xlrec->bm_bitmap_blkno, false);
+		if (!BufferIsValid(bitmapBuffer))
+			elog(PANIC, "bm_insert_redo: (_bitmap_xlog_insert_bitmap) "
+						"block unfound: %d",
+				 xlrec->bm_bitmap_blkno);
+
+		bitmapPage = BufferGetPage(bitmapBuffer);
+
+		if (XLByteLT(PageGetLSN(bitmapPage), lsn))
+		{
+			BMBitmap	bitmap;
+			BM_HRL_WORD*	bitmapWords = (BM_HRL_WORD*)
+				(((char*)xlrec) + MAXALIGN(sizeof(xl_bm_bitmappage)));
+
+			bitmapPageOpaque =
+				(BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);;
+			bitmap = (BMBitmap) PageGetContents(bitmapPage);
+
+			bitmapPageOpaque->bm_last_tid_location =
+				xlrec->bm_last_tid_location;
+			bitmapPageOpaque->bm_hrl_words_used =
+				xlrec->bm_hrl_words_used;
+
+			/* copy the header words and the content words */
+			memcpy(bitmap->bm_headerWords,
+				   xlrec->bm_headerWords,
+				   BM_MAX_NUM_OF_HEADER_WORDS*sizeof(BM_HRL_WORD));
+			memcpy((bitmap->bm_contentWords +
+					(bitmapPageOpaque->bm_hrl_words_used-
+					 xlrec->bm_num_words)),
+				   bitmapWords,
+				   xlrec->bm_num_words*sizeof(BM_HRL_WORD));
+
+			if (xlrec->bm_isOpaque)
+			{
+				/* copy the block number for the next page */
+				if (bitmapPageOpaque->bm_bitmap_next != InvalidBlockNumber)
+					elog(PANIC, 
+						"%s next bitmap page for blkno %d is already set",
+						"bm_insert_redo: ",
+						xlrec->bm_bitmap_blkno);
+				/*Assert(bitmapPageOpaque->bm_hrl_words_used == 
+						BM_NUM_OF_HRL_WORDS_PER_PAGE);*/
+
+				bitmapPageOpaque->bm_bitmap_next = xlrec->bm_next_blkno;
+			}
+
+			PageSetLSN(bitmapPage, lsn);
+			PageSetTLI(bitmapPage, ThisTimeLineID);
+			_bitmap_wrtbuf(bitmapBuffer);
+		}
+		else
+			_bitmap_relbuf(bitmapBuffer);
+	}
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+/*
+ * _bitmap_xlog_insert_bitmap_lastwords() -- update the last two words
+ * in a bitmap vector.
+ */
+static void
+_bitmap_xlog_insert_bitmap_lastwords(bool redo, XLogRecPtr lsn, XLogRecord* record)
+{
+	xl_bm_bitmap_lastwords	*xlrec = 
+		(xl_bm_bitmap_lastwords*) XLogRecGetData(record);
+	Relation reln;
+
+	reln = XLogOpenRelation(xlrec->bm_node);
+	if (!RelationIsValid(reln))
+		return;
+
+	if (redo)
+	{
+		Buffer		lovBuffer;
+		Page		lovPage;
+		BMLOVItem	lovItem;
+
+		lovBuffer = XLogReadBuffer(reln, xlrec->bm_lov_blkno, false);
+		if (!BufferIsValid(lovBuffer))
+			elog(PANIC, "bm_insert_redo: (_bitmap_xlog_insert_bitmap_lastwords) "
+						"block unfound: %d",
+				 xlrec->bm_lov_blkno);
+
+		lovPage = BufferGetPage(lovBuffer);
+
+		if (XLByteLT(PageGetLSN(lovPage), lsn))
+		{
+			lovItem = (BMLOVItem)
+				PageGetItem(lovPage, PageGetItemId(lovPage, xlrec->bm_lov_offset));
+
+			lovItem->bm_last_compword = xlrec->bm_last_compword;
+			lovItem->bm_last_word = xlrec->bm_last_word;
+			lovItem->bm_last_two_headerbits = xlrec->bm_last_two_headerbits;
+
+			PageSetLSN(lovPage, lsn);
+			PageSetTLI(lovPage, ThisTimeLineID);
+			_bitmap_wrtbuf(lovBuffer);
+		}
+		else
+			_bitmap_relbuf(lovBuffer);
+	}
+	else
+		elog(PANIC, "bm_insert_undo: not implemented.");
+}
+
+void
+bitmap_redo(XLogRecPtr lsn, XLogRecord* record)
+{
+	uint8	info = record->xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWMETA:
+			_bitmap_xlog_newpage(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWLOV:
+			_bitmap_xlog_newpage(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_LOVITEM:
+			_bitmap_xlog_insert_lovitem(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_META:
+			_bitmap_xlog_insert_meta(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+			_bitmap_xlog_newpage(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP:
+			_bitmap_xlog_insert_bitmap(true, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+			_bitmap_xlog_insert_bitmap_lastwords(true, lsn, record);
+			break;
+		default:
+			elog(PANIC, "bitmap_redo: unknown op code %u", info);
+	}
+}
+
+void
+bitmap_undo(XLogRecPtr lsn, XLogRecord *record)
+{
+	uint8		info = record->xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWMETA:
+			_bitmap_xlog_newpage(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWLOV:
+			_bitmap_xlog_newpage(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_LOVITEM:
+			_bitmap_xlog_insert_lovitem(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_META:
+			_bitmap_xlog_insert_meta(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+			_bitmap_xlog_newpage(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP:
+			_bitmap_xlog_insert_bitmap(false, lsn, record);
+			break;
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+			_bitmap_xlog_insert_bitmap_lastwords(false, lsn, record);
+			break;
+
+		default:
+			elog(PANIC, "bitmap_undo: unknown op code %u", info);
+	}
+}
+
+static void
+out_target(StringInfo buf, RelFileNode* node)
+{
+	appendStringInfo(buf, "rel %u/%u/%u",
+			node->spcNode, node->dbNode, node->relNode);
+}
+
+void
+bitmap_desc(StringInfo buf, uint8 xl_info, char* rec)
+{
+	uint8		info = xl_info & ~XLR_INFO_MASK;
+
+	switch (info)
+	{
+		case XLOG_BITMAP_INSERT_NEWMETA:
+		{
+			xl_bm_newpage *xlrec = (xl_bm_newpage*)rec;
+
+			appendStringInfo(buf, "insert a new metapage: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_NEWLOV:
+		{
+			xl_bm_newpage *xlrec = (xl_bm_newpage*)rec;
+
+			appendStringInfo(buf, "insert a new LOV page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_LOVITEM:
+		{
+			xl_bm_lovitem *xlrec = (xl_bm_lovitem*)rec;
+
+			appendStringInfo(buf, "insert a new LOV item: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_META:
+		{
+			xl_bm_metapage *xlrec = (xl_bm_metapage*)rec;
+
+			appendStringInfo(buf, "update the metapage: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_NEWBITMAP:
+		{
+			xl_bm_newpage *xlrec = (xl_bm_newpage*)rec;
+
+			appendStringInfo(buf, "insert a new bitmap page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_BITMAP:
+		{
+			xl_bm_bitmappage *xlrec = (xl_bm_bitmappage*)rec;
+
+			appendStringInfo(buf, "update a bitmap page: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+		case XLOG_BITMAP_INSERT_BITMAP_LASTWORDS:
+		{
+			xl_bm_bitmap_lastwords *xlrec = (xl_bm_bitmap_lastwords*)rec;
+
+			appendStringInfo(buf, "update the last two words in a bitmap: ");
+			out_target(buf, &(xlrec->bm_node));
+			break;
+		}
+
+		default:
+			appendStringInfo(buf, "UNKNOWN");
+			break;
+	}
+}
diff -Naur src.pgsql/backend/access/gin/ginget.c src.bitmap/backend/access/gin/ginget.c
--- src.pgsql/backend/access/gin/ginget.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/gin/ginget.c	2006-09-17 00:09:28.000000000 -0700
@@ -15,6 +15,8 @@
 #include "postgres.h"
 #include "access/gin.h"
 #include "catalog/index.h"
+#include "miscadmin.h"
+#include "nodes/tidbitmap.h"
 #include "utils/memutils.h"
 
 static OffsetNumber
@@ -362,30 +364,36 @@
 
 #define GinIsNewKey(s)		( ((GinScanOpaque) scan->opaque)->keys == NULL )
 
-Datum 
-gingetmulti(PG_FUNCTION_ARGS) {
-    IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
-	ItemPointer tids = (ItemPointer) PG_GETARG_POINTER(1);
-	int32       max_tids = PG_GETARG_INT32(2);
-	int32      *returned_tids = (int32 *) PG_GETARG_POINTER(3);
+Datum
+gingetbitmap(PG_FUNCTION_ARGS)
+{
+	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
+	HashBitmap	*hashBitmap = (HashBitmap*) PG_GETARG_POINTER(1);
+	/* this will be ignored since we return a hash bitmap. */
+	/* BlockNumber	  nextBlockNo = PG_GETARG_UINT32(2);*/
+
+	if (hashBitmap == NULL)
+	{
+		/* XXX should we use less than work_mem for this? */
+		hashBitmap = tbm_create(work_mem * 1024L);
+	}
 
 	if ( GinIsNewKey(scan) )
 		newScanKey( scan );
 
 	startScan( scan );
 
-	*returned_tids = 0;
-
 	do {
-		if ( scanGetItem( scan, tids + *returned_tids ) ) 
-			(*returned_tids)++;
+		ItemPointerData	tid;
+		if ( scanGetItem( scan, &tid) )
+			tbm_add_tuples(hashBitmap, &tid, 1);
 		else
 			break;
-	} while ( *returned_tids < max_tids );
+	} while ( true );
 
 	stopScan( scan );
 
-	PG_RETURN_BOOL(*returned_tids == max_tids);
+	PG_RETURN_POINTER(hashBitmap);
 }
 
 Datum
diff -Naur src.pgsql/backend/access/gist/gistget.c src.bitmap/backend/access/gist/gistget.c
--- src.pgsql/backend/access/gist/gistget.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/gist/gistget.c	2006-09-17 01:24:53.000000000 -0700
@@ -17,6 +17,8 @@
 #include "access/gist_private.h"
 #include "executor/execdebug.h"
 #include "pgstat.h"
+#include "miscadmin.h"
+#include "nodes/tidbitmap.h"
 #include "utils/memutils.h"
 
 
@@ -120,16 +122,27 @@
 }
 
 Datum
-gistgetmulti(PG_FUNCTION_ARGS)
+gistgetbitmap(PG_FUNCTION_ARGS)
 {
+#define MAX_TIDS	1024
+	ItemPointerData tids[MAX_TIDS];
+	int32		ntids = 0;
+
 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
-	ItemPointer tids = (ItemPointer) PG_GETARG_POINTER(1);
-	int32		max_tids = PG_GETARG_INT32(2);
-	int32	   *returned_tids = (int32 *) PG_GETARG_POINTER(3);
+	HashBitmap	*hashBitmap = (HashBitmap*) PG_GETARG_POINTER(1);
+	/* this will be ignored since we return a hash bitmap. */
+	/* BlockNumber	  nextBlockNo = PG_GETARG_UINT32(2);*/
+
+	if (hashBitmap == NULL)
+	{
+		/* XXX should we use less than work_mem for this? */
+		hashBitmap = tbm_create(work_mem * 1024L);
+	}
 
-	*returned_tids = gistnext(scan, ForwardScanDirection, tids, max_tids, false);
+	while ((ntids = gistnext(scan, ForwardScanDirection, tids, MAX_TIDS, false)) > 0)
+		tbm_add_tuples(hashBitmap, tids, ntids);
 
-	PG_RETURN_BOOL(*returned_tids == max_tids);
+	PG_RETURN_POINTER(hashBitmap);
 }
 
 /*
diff -Naur src.pgsql/backend/access/hash/hash.c src.bitmap/backend/access/hash/hash.c
--- src.pgsql/backend/access/hash/hash.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/hash/hash.c	2006-09-17 00:09:28.000000000 -0700
@@ -17,12 +17,13 @@
  */
 
 #include "postgres.h"
-
+#include "miscadmin.h"
 #include "access/genam.h"
 #include "access/hash.h"
 #include "catalog/index.h"
 #include "commands/vacuum.h"
-
+#include "miscadmin.h"
+#include "nodes/tidbitmap.h"
 
 /* Working state for hashbuild and its callback */
 typedef struct
@@ -237,25 +238,26 @@
 	PG_RETURN_BOOL(res);
 }
 
-
 /*
- *	hashgetmulti() -- get multiple tuples at once
- *
- * This is a somewhat generic implementation: it avoids lock reacquisition
- * overhead, but there's no smarts about picking especially good stopping
- * points such as index page boundaries.
+ * hashgetbitmap() -- get the next bitmap for the scan.
  */
 Datum
-hashgetmulti(PG_FUNCTION_ARGS)
+hashgetbitmap(PG_FUNCTION_ARGS)
 {
 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
-	ItemPointer tids = (ItemPointer) PG_GETARG_POINTER(1);
-	int32		max_tids = PG_GETARG_INT32(2);
-	int32	   *returned_tids = (int32 *) PG_GETARG_POINTER(3);
+	HashBitmap	*hashBitmap = (HashBitmap*) PG_GETARG_POINTER(1);
+	/* this will be ignored since we return a hash bitmap. */
+	/* BlockNumber	  nextBlockNo = PG_GETARG_UINT32(2); */
+
 	HashScanOpaque so = (HashScanOpaque) scan->opaque;
 	Relation	rel = scan->indexRelation;
 	bool		res = true;
-	int32		ntids = 0;
+
+	if (hashBitmap == NULL)
+	{
+		/* XXX should we use less than work_mem for this? */
+		hashBitmap = tbm_create(work_mem * 1024L);
+	}
 
 	/*
 	 * We hold pin but not lock on current buffer while outside the hash AM.
@@ -264,7 +266,7 @@
 	if (BufferIsValid(so->hashso_curbuf))
 		_hash_chgbufaccess(rel, so->hashso_curbuf, HASH_NOLOCK, HASH_READ);
 
-	while (ntids < max_tids)
+	while (true)
 	{
 		/*
 		 * Start scan, or advance to next tuple.
@@ -295,18 +297,17 @@
 		if (!res)
 			break;
 		/* Save tuple ID, and continue scanning */
-		tids[ntids] = scan->xs_ctup.t_self;
-		ntids++;
+		tbm_add_tuples(hashBitmap, &(scan->xs_ctup.t_self), 1);
 	}
 
 	/* Release read lock on current buffer, but keep it pinned */
 	if (BufferIsValid(so->hashso_curbuf))
 		_hash_chgbufaccess(rel, so->hashso_curbuf, HASH_READ, HASH_NOLOCK);
 
-	*returned_tids = ntids;
-	PG_RETURN_BOOL(res);
-}
+	tbm_begin_iterate(hashBitmap);
 
+	PG_RETURN_POINTER(hashBitmap);
+}
 
 /*
  *	hashbeginscan() -- start a scan on a hash index
diff -Naur src.pgsql/backend/access/index/genam.c src.bitmap/backend/access/index/genam.c
--- src.pgsql/backend/access/index/genam.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/index/genam.c	2006-09-17 00:09:29.000000000 -0700
@@ -86,7 +86,7 @@
 	else
 		scan->keyData = NULL;
 
-	scan->is_multiscan = false;			/* caller may change this */
+	scan->is_bitmapscan = false;			/* caller may change this */
 	scan->kill_prior_tuple = false;
 	scan->ignore_killed_tuples = true;	/* default setting */
 
diff -Naur src.pgsql/backend/access/index/indexam.c src.bitmap/backend/access/index/indexam.c
--- src.pgsql/backend/access/index/indexam.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/index/indexam.c	2006-09-17 00:09:29.000000000 -0700
@@ -14,14 +14,15 @@
  *		index_open		- open an index relation by relation OID
  *		index_close		- close an index relation
  *		index_beginscan - start a scan of an index with amgettuple
- *		index_beginscan_multi - start a scan of an index with amgetmulti
+ *		index_beginscan_bitmap - start a scan of an index with 
+ *								 amgetbitmap
  *		index_rescan	- restart a scan of an index
  *		index_endscan	- end a scan
  *		index_insert	- insert an index tuple into a relation
  *		index_markpos	- mark a scan position
  *		index_restrpos	- restore a scan position
  *		index_getnext	- get the next tuple from a scan
- *		index_getmulti	- get multiple tuples from a scan
+ *		index_getbitmap - get the next bitmap from a scan
  *		index_bulk_delete	- bulk deletion of index tuples
  *		index_vacuum_cleanup	- post-deletion cleanup of an index
  *		index_getprocid - get a support procedure OID
@@ -226,7 +227,7 @@
 	 * Save additional parameters into the scandesc.  Everything else was set
 	 * up by RelationGetIndexScan.
 	 */
-	scan->is_multiscan = false;
+	scan->is_bitmapscan = false;
 	scan->heapRelation = heapRelation;
 	scan->xs_snapshot = snapshot;
 
@@ -234,30 +235,37 @@
 }
 
 /*
- * index_beginscan_multi - start a scan of an index with amgetmulti
+ * index_beginscan_bitmap - start a scan of an index 
+ * 							with amgetbitmap
  *
  * As above, caller had better be holding some lock on the parent heap
  * relation, even though it's not explicitly mentioned here.
  */
 IndexScanDesc
-index_beginscan_multi(Relation indexRelation,
-					  Snapshot snapshot,
-					  int nkeys, ScanKey key)
+index_beginscan_bitmap(Relation indexRelation,
+					   Snapshot snapshot,
+					   int nkeys, ScanKey key)
 {
 	IndexScanDesc scan;
 
 	scan = index_beginscan_internal(indexRelation, nkeys, key);
+	/*
+	 * Save additional parameters into the scandesc.  Everything else was
+	 * set up by RelationGetIndexScan.
+	 */
+	scan->xs_snapshot = snapshot;
 
 	/*
-	 * Save additional parameters into the scandesc.  Everything else was set
-	 * up by RelationGetIndexScan.
+	 * Save additional parameters into the scandesc.  Everything else was
+	 * set up by RelationGetIndexScan.
 	 */
-	scan->is_multiscan = true;
+	scan->is_bitmapscan = true;
 	scan->xs_snapshot = snapshot;
 
 	return scan;
 }
 
+
 /*
  * index_beginscan_internal --- common code for index_beginscan variants
  */
@@ -507,45 +515,34 @@
 	return found;
 }
 
-/* ----------------
- *		index_getmulti - get multiple tuples from an index scan
- *
- * Collects the TIDs of multiple heap tuples satisfying the scan keys.
- * Since there's no interlock between the index scan and the eventual heap
- * access, this is only safe to use with MVCC-based snapshots: the heap
- * item slot could have been replaced by a newer tuple by the time we get
- * to it.
- *
- * A TRUE result indicates more calls should occur; a FALSE result says the
- * scan is done.  *returned_tids could be zero or nonzero in either case.
- * ----------------
+/*
+ *		index_getbitmap - get the next bitmap from an index scan.
  */
-bool
-index_getmulti(IndexScanDesc scan,
-			   ItemPointer tids, int32 max_tids,
-			   int32 *returned_tids)
+Node*
+index_getbitmap(IndexScanDesc	scan,
+				HashBitmap*		hashBitmap,
+				BlockNumber		nextBlockNo)
 {
 	FmgrInfo   *procedure;
-	bool		found;
+	Node		*bitmap;
 
 	SCAN_CHECKS;
-	GET_SCAN_PROCEDURE(amgetmulti);
+	GET_SCAN_PROCEDURE(amgetbitmap);
 
 	/* just make sure this is false... */
 	scan->kill_prior_tuple = false;
 
 	/*
-	 * have the am's getmulti proc do all the work.
+	 * have the am's getbitmap proc do all the work. 
+	 * index_beginscan_bitmap already set up fn_getbitmap.
 	 */
-	found = DatumGetBool(FunctionCall4(procedure,
-									   PointerGetDatum(scan),
-									   PointerGetDatum(tids),
-									   Int32GetDatum(max_tids),
-									   PointerGetDatum(returned_tids)));
-
-	pgstat_count_index_tuples(&scan->xs_pgstat_info, *returned_tids);
+	bitmap = (Node*)
+		DatumGetPointer(FunctionCall3(procedure,
+									  PointerGetDatum(scan),
+									  PointerGetDatum(hashBitmap),
+									  Int32GetDatum(nextBlockNo)));
 
-	return found;
+	return bitmap;
 }
 
 /* ----------------
diff -Naur src.pgsql/backend/access/nbtree/nbtree.c src.bitmap/backend/access/nbtree/nbtree.c
--- src.pgsql/backend/access/nbtree/nbtree.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/nbtree/nbtree.c	2006-09-17 00:09:28.000000000 -0700
@@ -22,6 +22,8 @@
 #include "access/nbtree.h"
 #include "catalog/index.h"
 #include "commands/vacuum.h"
+#include "miscadmin.h"
+#include "nodes/tidbitmap.h"
 #include "storage/freespace.h"
 #include "storage/lmgr.h"
 #include "utils/memutils.h"
@@ -277,42 +279,37 @@
 }
 
 /*
- * btgetmulti() -- get multiple tuples at once
- *
- * In the current implementation there seems no strong reason to stop at
- * index page boundaries; we just press on until we fill the caller's buffer
- * or run out of matches.
+ * btgetbitmap() -- construct a HashBitmap.
  */
 Datum
-btgetmulti(PG_FUNCTION_ARGS)
+btgetbitmap(PG_FUNCTION_ARGS)
 {
 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
-	ItemPointer tids = (ItemPointer) PG_GETARG_POINTER(1);
-	int32		max_tids = PG_GETARG_INT32(2);
-	int32	   *returned_tids = (int32 *) PG_GETARG_POINTER(3);
+	HashBitmap	*hashBitmap = (HashBitmap*) PG_GETARG_POINTER(1);
+	/* this will be ignored since we return a hash bitmap. */
+	/* BlockNumber	  nextBlockNo = PG_GETARG_UINT32(2);*/
+
 	BTScanOpaque so = (BTScanOpaque) scan->opaque;
 	bool		res = true;
-	int32		ntids = 0;
 
-	if (max_tids <= 0)			/* behave correctly in boundary case */
-		PG_RETURN_BOOL(true);
+	if (hashBitmap == NULL)
+	{
+		/* XXX should we use less than work_mem for this? */
+		hashBitmap = tbm_create(work_mem * 1024L);
+	}
 
 	/* If we haven't started the scan yet, fetch the first page & tuple. */
 	if (!BTScanPosIsValid(so->currPos))
 	{
 		res = _bt_first(scan, ForwardScanDirection);
-		if (!res)
+		if (res)
 		{
-			/* empty scan */
-			*returned_tids = ntids;
-			PG_RETURN_BOOL(res);
+			/* Save tuple ID, and continue scanning */
+			tbm_add_tuples(hashBitmap, &(scan->xs_ctup.t_self), 1);
 		}
-		/* Save tuple ID, and continue scanning */
-		tids[ntids] = scan->xs_ctup.t_self;
-		ntids++;
 	}
 
-	while (ntids < max_tids)
+	while (res)
 	{
 		/*
 		 * Advance to next tuple within page.  This is the same as the
@@ -327,12 +324,12 @@
 		}
 
 		/* Save tuple ID, and continue scanning */
-		tids[ntids] = so->currPos.items[so->currPos.itemIndex].heapTid;
-		ntids++;
+		tbm_add_tuples(hashBitmap,
+					   &(so->currPos.items[so->currPos.itemIndex].heapTid),
+					   1);
 	}
 
-	*returned_tids = ntids;
-	PG_RETURN_BOOL(res);
+	PG_RETURN_POINTER(hashBitmap);
 }
 
 /*
diff -Naur src.pgsql/backend/access/transam/rmgr.c src.bitmap/backend/access/transam/rmgr.c
--- src.pgsql/backend/access/transam/rmgr.c	2006-09-16 17:51:42.000000000 -0700
+++ src.bitmap/backend/access/transam/rmgr.c	2006-09-17 00:09:28.000000000 -0700
@@ -14,6 +14,7 @@
 #include "access/heapam.h"
 #include "access/multixact.h"
 #include "access/nbtree.h"
+#include "access/bitmap.h"
 #include "access/xact.h"
 #include "access/xlog_internal.h"
 #include "commands/dbcommands.h"
@@ -38,5 +39,6 @@
 	{"Hash", hash_redo, hash_desc, NULL, NULL, NULL},
 	{"Gin", gin_redo, gin_desc, gin_xlog_startup, gin_xlog_cleanup, gin_safe_restartpoint},
 	{"Gist", gist_redo, gist_desc, gist_xlog_startup, gist_xlog_cleanup, gist_safe_restartpoint},
-	{"Sequence", seq_redo, seq_desc, NULL, NULL, NULL}
+	{"Sequence", seq_redo, seq_desc, NULL, NULL, NULL},
+ 	{"Bitmap", bitmap_redo, bitmap_desc, NULL, NULL, NULL}
 };
